function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(n);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) {
    arr2[i] = arr[i];
  }

  return arr2;
}

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    _typeof = function _typeof(obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _createSuper(Derived) {
  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (_isNativeReflectConstruct()) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _possibleConstructorReturn(self, call) {
  if (call && (_typeof(call) === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? new Map() : undefined;

  _wrapNativeSuper = function _wrapNativeSuper(Class) {
    if (Class === null || !_isNativeFunction(Class)) return Class;

    if (typeof Class !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }

    if (typeof _cache !== "undefined") {
      if (_cache.has(Class)) return _cache.get(Class);

      _cache.set(Class, Wrapper);
    }

    function Wrapper() {
      return _construct(Class, arguments, _getPrototypeOf(this).constructor);
    }

    Wrapper.prototype = Object.create(Class.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class);
  };

  return _wrapNativeSuper(Class);
}

function _construct(Parent, args, Class) {
  if (_isNativeReflectConstruct()) {
    _construct = Reflect.construct;
  } else {
    _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) _setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }

  return _construct.apply(null, arguments);
}

function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

import { compile as compilePath, match as matchPath, parse as parsePath, pathToRegexp } from 'path-to-regexp';
import { parse as parseQuery, stringify as stringifyQuery } from 'query-string'; // Errors

export var RouteMatchError = /*#__PURE__*/function (_Error) {
  _inherits(RouteMatchError, _Error);

  var _super = _createSuper(RouteMatchError);

  function RouteMatchError() {
    _classCallCheck(this, RouteMatchError);

    return _super.apply(this, arguments);
  }

  return RouteMatchError;
}( /*#__PURE__*/_wrapNativeSuper(Error));
export var LocationMatchError = /*#__PURE__*/function (_Error2) {
  _inherits(LocationMatchError, _Error2);

  var _super2 = _createSuper(LocationMatchError);

  function LocationMatchError() {
    _classCallCheck(this, LocationMatchError);

    return _super2.apply(this, arguments);
  }

  return LocationMatchError;
}( /*#__PURE__*/_wrapNativeSuper(Error)); // Action Types

var createType = function createType(type) {
  return '@@reduxRoutable/' + type;
};

var SYNC = createType('SYNC');
var PUSH = createType('PUSH');
var REPLACE = createType('REPLACE');
var OPEN = createType('OPEN');
var GO = createType('GO');
var GO_BACK = createType('GO_BACK');
var GO_FORWARD = createType('GO_FORWARD');
export var ROUTE_CHANGED = createType('ROUTE_CHANGED');
export var ROUTE_NOT_MATCHED = createType('ROUTE_NOT_MATCHED');
export var LOCATION_NOT_MATCHED = createType('LOCATION_NOT_MATCHED'); // Action Creators

export var sync = function sync() {
  return {
    type: SYNC
  };
};
export var push = function push(route) {
  var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var hash = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
  return {
    type: PUSH,
    payload: {
      route: route,
      params: params,
      hash: hash
    }
  };
};
export var replace = function replace(route) {
  var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var hash = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
  return {
    type: REPLACE,
    payload: {
      route: route,
      params: params,
      hash: hash
    }
  };
};
export var open = function open(route) {
  var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var hash = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
  return {
    type: OPEN,
    payload: {
      route: route,
      params: params,
      hash: hash
    }
  };
};
export var go = function go(offset) {
  return {
    type: GO,
    payload: offset
  };
};
export var goBack = function goBack() {
  return {
    type: GO_BACK
  };
};
export var goForward = function goForward() {
  return {
    type: GO_FORWARD
  };
};

var routeChanged = function routeChanged(route, params, hash, previous) {
  return {
    type: ROUTE_CHANGED,
    payload: {
      route: route,
      params: params,
      hash: hash
    },
    meta: {
      previous: previous
    }
  };
};

var routeNotMatched = function routeNotMatched(error, route, params, hash) {
  return {
    type: ROUTE_NOT_MATCHED,
    error: true,
    payload: error,
    meta: {
      route: route,
      params: params,
      hash: hash
    }
  };
};

var locationNotMatched = function locationNotMatched(error, location) {
  return {
    type: LOCATION_NOT_MATCHED,
    error: true,
    payload: error,
    meta: {
      location: location
    }
  };
}; // Router Configuration


var createConfig = function createConfig(constructor, properties) {
  var instance = Object.create(constructor.prototype);
  return Object.assign(instance, properties);
};

export function Route(name) {
  var path = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  if (name === undefined) {
    throw new TypeError("'name' cannot be undefined");
  }

  if (typeof path !== 'string') {
    throw new TypeError("".concat(path, " is not a string"));
  }

  return createConfig(Route, {
    name: name,
    path: path,
    pattern: pathToRegexp(path)
  });
}
export function Redirect(to) {
  var path = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  if (to === undefined) {
    throw new TypeError("'to' cannot be undefined");
  }

  if (typeof path !== 'string') {
    throw new TypeError("".concat(path, " is not a string"));
  }

  return createConfig(Redirect, {
    to: to,
    path: path,
    pattern: pathToRegexp(path)
  });
}
export function Fallback(name) {
  var path = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  if (name === undefined) {
    throw new TypeError("'name' cannot be undefined");
  }

  if (typeof path !== 'string') {
    throw new TypeError("".concat(path, " is not a string"));
  }

  var pattern = pathToRegexp(path, null, {
    end: false
  });
  return createConfig(Fallback, {
    name: name,
    path: '',
    pattern: pattern
  });
}
export function Scope(base, router) {
  if (typeof base !== 'string') {
    throw new TypeError("".concat(base, " is not a string"));
  }

  if (!(router instanceof Router)) {
    throw new TypeError("".concat(router, " is not a Router"));
  }

  var scopedChildren = router.children.map(function (child) {
    switch (child.constructor) {
      case Fallback:
        return Fallback(child.name, base + child.path);

      case Redirect:
        return Redirect(child.to, base + child.path);

      case Route:
        return Route(child.name, base + child.path);
    }
  });
  return createConfig(Scope, {
    base: base,
    children: scopedChildren
  });
}
export function Router(children) {
  if (!(children instanceof Array)) {
    throw new TypeError("".concat(children, " is not an Array"));
  }

  var resolvedChildren = children.reduce(function (children, child) {
    switch (child.constructor) {
      case Scope:
        return children.concat(child.children);

      case Fallback:
      case Redirect:
      case Route:
        return children.concat([child]);

      default:
        throw new TypeError("".concat(child, " is not a valid Router child"));
    }
  }, []);
  return createConfig(Router, {
    children: resolvedChildren
  });
} // Helpers

export var match = function match(route, matchable) {
  if (_typeof(matchable) === 'object') {
    switch (matchable.constructor) {
      case Route:
      case Fallback:
        return match(route, matchable.name);

      case Router:
      case Scope:
        return match(route, matchable.children);

      case Array:
        return matchable.some(function (child) {
          return match(route, child);
        });

      default:
        return route === matchable;
    }
  } else {
    return route === matchable;
  }
};
export var paramsReducer = function paramsReducer(matchable) {
  for (var _len = arguments.length, rest = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    rest[_key - 1] = arguments[_key];
  }

  var _ref = rest.length === 1 ? [null].concat(rest) : rest,
      _ref2 = _slicedToArray(_ref, 2),
      awayVal = _ref2[0],
      paramsSelector = _ref2[1];

  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : awayVal;

    var _ref3 = arguments.length > 1 ? arguments[1] : undefined,
        type = _ref3.type,
        payload = _ref3.payload;

    if (type === ROUTE_CHANGED) {
      if (match(payload.route, matchable)) {
        return paramsSelector(payload.params);
      } else {
        return awayVal;
      }
    } else {
      return state;
    }
  };
};
export var changedTo = function changedTo(matchable) {
  return function (_ref4) {
    var type = _ref4.type,
        payload = _ref4.payload;
    return type === ROUTE_CHANGED && match(payload.route, matchable);
  };
};
export var entered = function entered(matchable) {
  return function (_ref5) {
    var type = _ref5.type,
        payload = _ref5.payload,
        meta = _ref5.meta;
    return type === ROUTE_CHANGED && match(payload.route, matchable) && (meta.previous === undefined || !match(meta.previous.route, matchable));
  };
};
export var exited = function exited(matchable) {
  return function (_ref6) {
    var type = _ref6.type,
        payload = _ref6.payload,
        meta = _ref6.meta;
    return type === ROUTE_CHANGED && !match(payload.route, matchable) && meta.previous !== undefined && match(meta.previous.route, matchable);
  };
}; // Utilities

var getPathParamNames = function getPathParamNames(path) {
  return parsePath(path).slice(1).map(function (token) {
    return token.name;
  });
};

var keyFilter = function keyFilter(object, condition) {
  return Object.entries(object).reduce(function (params, _ref7) {
    var _ref8 = _slicedToArray(_ref7, 2),
        key = _ref8[0],
        val = _ref8[1];

    if (condition(key)) params[key] = val;
    return params;
  }, {});
}; // Route/Location Translation


export var routeToLocation = function routeToLocation(router, name, params, hash) {
  var route = router.children.find(function (child) {
    return child instanceof Route && child.name === name;
  });

  if (route === undefined) {
    throw new RouteMatchError("No route matching route name: ".concat(name));
  }

  var pathParamNames = getPathParamNames(route.path);
  var pathParams = keyFilter(params, function (key) {
    return pathParamNames.includes(key);
  });
  var queryParams = keyFilter(params, function (key) {
    return !pathParamNames.includes(key);
  });
  var search = stringifyQuery(queryParams);
  var pathname;

  try {
    pathname = compilePath(route.path)(pathParams);
  } catch (error) {
    throw new RouteMatchError(error.message);
  }

  return {
    pathname: pathname,
    search: search,
    hash: hash
  };
};
export var locationToRoute = function locationToRoute(router, _ref9) {
  var pathname = _ref9.pathname,
      search = _ref9.search,
      hash = _ref9.hash;
  var route = router.children.find(function (child) {
    return child.pattern.test(pathname);
  });

  if (route === undefined) {
    throw new LocationMatchError("No route matching location path: ".concat(pathname));
  }

  var pathParams = matchPath(route.path)(pathname).params;
  var queryParams = parseQuery(search);

  var params = _objectSpread({}, pathParams, {}, queryParams);

  return {
    route: route,
    params: params,
    hash: hash
  };
}; // Middleware

var isAbsoluteAction = function isAbsoluteAction(_ref10) {
  var type = _ref10.type;
  return [PUSH, REPLACE, OPEN].includes(type);
};

var isRelativeAction = function isRelativeAction(_ref11) {
  var type = _ref11.type;
  return [GO, GO_BACK, GO_FORWARD].includes(type);
};

export var createMiddleware = function createMiddleware(router, history) {
  return function (store) {
    var previous;

    var historyListener = function historyListener(location) {
      try {
        var _locationToRoute = locationToRoute(router, location),
            route = _locationToRoute.route,
            params = _locationToRoute.params,
            hash = _locationToRoute.hash;

        if (route instanceof Redirect) {
          history.replace(routeToLocation(router, route.to, params, hash));
        } else {
          store.dispatch(routeChanged(route.name, params, hash, previous));
        }
      } catch (error) {
        if (error instanceof LocationMatchError) {
          store.dispatch(locationNotMatched(error, location));
        } else {
          throw error;
        }
      }
    };

    history.listen(historyListener);
    return function (next) {
      return function (action) {
        if (action.type === SYNC) {
          historyListener(history.location);
        } else if (isAbsoluteAction(action)) {
          var _action$payload = action.payload,
              route = _action$payload.route,
              params = _action$payload.params,
              hash = _action$payload.hash;

          try {
            var location = routeToLocation(router, route, params, hash);

            switch (action.type) {
              case PUSH:
                history.push(location);
                break;

              case REPLACE:
                history.replace(location);
                break;

              case OPEN:
                window.open(history.createHref(location));
                break;
            }
          } catch (error) {
            if (error instanceof RouteMatchError) {
              store.dispatch(routeNotMatched(error, route, params, hash));
            } else {
              throw error;
            }
          }
        } else if (isRelativeAction(action)) {
          switch (action.type) {
            case GO:
              history.go(action.payload);
              break;

            case GO_BACK:
              history.goBack();
              break;

            case GO_FORWARD:
              history.goForward();
              break;
          }
        } else {
          if (action.type === ROUTE_CHANGED) {
            previous = action.payload;
          }

          return next(action);
        }
      };
    };
  };
};